import es, popuplib, random, services, cfglib


# Config
config = cfglib.AddonCFG(es.getAddonPath("dissolver") + "/dissolver.cfg")
config.text("********************")
config.text(" Dissolver Settings ")
config.text("********************")
deathtype = config.cvar("deathtype",      1, "Death Type: 1 = no dissovle, 2 =  Energy Effect ,3 = Heavy Electrical Effect, 4 = Light Electrical  Effect,5 = Core Effect,6 = Random")
command = config.cvar("command",      '!dissolve', "What you type to bring up the menu")

# Config

# Public #
info = es.AddonInfo()
info.name     = "Dissolver"
info.version  = "0.1"
info.url      = "None"
info.basename = "sic_dissolver"
info.author   = "sicman_adrian"
es.ServerVar('sic_dissolver', info.version, 'Body Dissolver').makepublic()
#Public#
gamename = str(es.ServerVar('eventscripts_gamedir')).replace('\\', '/').rsplit('/',1)[~0]
ragdoll = {'cstrike':'cs_ragdoll', 'hl2dm':'hl2dm_ragdoll', 'tf':'tf_ragdoll', 'dod':'dod_ragdoll'}.get(gamename)

def load():
    deathtypemenu = popuplib.create('deathtypemenu')
    deathtypemenu.addline('Dissolver Options')
    deathtypemenu.addline('-----------------------')
    deathtypemenu.addline('->1. No Dissovle')
    deathtypemenu.addline('->2. Energy Effect')
    deathtypemenu.addline('->3. Heavy Electrical Effect')
    deathtypemenu.addline('->4. Light Electrical')
    deathtypemenu.addline('->5. Core Effect')
    deathtypemenu.addline('->6. Random')
    deathtypemenu.addline('->0. Exit')
    deathtypemenu.addline('------------------------')
    deathtypemenu.menuselect = deathtypemenu_menuselect
    setup_auth()
    if not es.exists('saycommand', command):
        es.regsaycmd(command, 'dissolver/sendpopup')

def unload():
    if es.exists('saycommand', command):
        es.unregsaycmd(command)

def deathtypemenu_menuselect (userid, choice, popupid):
    global deathtype
    if choice in [1,2,3,4,5,6]:
        deathtype = choice
        popuplib.send('deathtypemenu', userid)

def player_death(ev):
    userid = int(ev['userid'])
    if deathtype == 6:
        mode = random.randint(1,5)
    else:
        mode = deathtype
    dissolve(userid, mode)

def dissolve(userid, mode):
    if mode == 1:
          es.server.queuecmd("es_fire %s %s kill" % (userid, ragdoll))
    else:
          es.server.queuecmd('es_give %s env_entity_dissolver' % userid)
          es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "target %s"' % (userid, ragdoll))
          es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "magnitude 1"' % userid)
          es.server.queuecmd('es_fire %s env_entity_dissolver AddOutput "dissolvetype %s"' % (userid,mode-2))
          es.server.queuecmd('es_fire %s env_entity_dissolver Dissolve' % userid) 

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('dissolve_admin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isUseridAuthorized(x, 'dissolve_admin')
    else:
        isAuthed = lambda x: False

def sendpopup():
    userid = es.getcmduserid()
    if isAuthed(userid):
        popuplib.send('deathtypemenu', userid)
    else:
        es.tell(userid, '#multi','#greenYou are not authorised to run the command admin!') 